; Star Ocean MSU1 patch

; $7e0190: fadeflag
; $7e0191: fade Volume
; $7e0192: track number
; $7e0193: previous track number
; $7e0194: resumeflag

hirom				

; hook to freespace
;org $c0864e ; Englisch, Japan
org $c085f8 ; Deutsch ; Spanish
	JSL msu


;org $C08599 ; Englisch, Japan
org $C08543 ; Deutsch, Spanisch
	JSL setFade
	
;org $C00231 ; Englisch, Japan
org $C0022f ; Deutsch, Spanisch
	JSL irq

;org $CC1d42; Englisch, Japan
org $CC1B8F ; Deutsch, Spanisch
	JML bugfix03

org $C4f5b2; (all versions)
	JSL bugfixFade ; bugFix with fade

;org $c21e6f ; Englisch, Japan
org $C21e5b ; Deutsch, Spanisch
	JSL resume ;bugfix to resume after battle
	NOP

org $c26b1d; (all versions)
	JSL resume ;bugfix to resume after battle
	NOP
	
org $c4f5cc; (all versions)
	JSL resume2 ;bugfix to resume after playing instrument
	NOP		

;org $cc37b2 ; Englisch, Japan
org $cc3590; Deutsch, Spanisch
	JSL previousTrack ; load previous theme after won battle

; freespace 2.5MB also translated rom
org $c4fb30 ; all versions
		
msu:
	PHA
	lda $002002
	CMP #$53
	BEQ $06
		PLA
		STA $BD
		REP #$20
		RTL
	PLA	
	CMP $7e0192
	BNE $07
		LDA #$01
		STA $BD
		REP #$20
		RTL
	cmp #$12
	BNE check02
	LDA $7e0194
	cmp #$01
	BEQ $06
	LDA #$04
	STA $002007
	LDA #$12
	check02:
	cmp #$02
	BNE $08
	LDA #$04
	STA $002007
	LDA #$02	
	STA $002004 ;store value to msu
	PHA
	PHP
	REP #$20
	LDA #$0000
	PLP
	LDA #$00
	STA $002006
	STA $002005
	STA $7e0190
	loop:
		LDA $002000
		AND #$40
		bne loop
	lda $002000
	AND #$08
	BEQ $06 ;no error, play pcm
		PLA
		STA $BD
		REP #$20
		RTL
	LDA $7e0194
	cmp #$02
	BEQ $04
	LDA #$ff
	BRA $02
	LDA #$00		
	STA $002006
	STA $7e0191
	LDA $7e0192	
	STA $7e0193	
	LDA #$00
	STA $7e0194
	PLA
	STA $7e0192
	PHX
	LDX #$0000
	TAX
	LDA $c4fe00,x
	STA $002007	
	PLX
	LDA #$01 ;mute SPC
	STA $BD
	REP #$20
	RTL	
	
setFade:	
	SEP #$20	
	STA $4B
	PHA
	lda $002002
	CMP #$53
	BEQ $02
		PLA
		RTL
	PLA
	cmp #$12
	BNE $03
	jmp fadeOut
	cmp #$13
	BNE $03
	jmp fadeFull
	cmp #$07
	BNE $03
	JMP fadeOut
	cmp #$08
	BNE $03
	JMP fadeOut	
	cmp #$0a
	BNE no0A
	JMP fadeFull	
no0A:
	
	; more commands to fadeout/ fadefull heres
	RTL
	fadeFull:
		PHA
		LDA #$01
		STA $7e0190
		PLA
		RTL
	fadeOut:
		PHA
		LDA #$02
		STA $7e0190
		LDA #$00
		STA $7e0192
		PLA
		RTL
		
irq:
	LDA $4211
	LDA $7e0190
	cmp #$01
	BEQ executeFull
	cmp #$02
	BEQ executeOut
	LDA $D8
	RTL
	executeFull:
		lda $7e0191
;		inc
		inc
		inc
		cmp #$fb
		bcc $08
		LDA #$00
		sta $7e0190
		lda #$FF
		sta $002006
		sta $7e0191
		LDA $D8
		RTL
	executeOut:	
		lda $7e0191
;		dec
		dec
		dec
		cmp #$10
		bcs $08
		LDA #$00
		sta $7e0190
		lda #$00
		sta $002006
		sta $7e0191
		LDA $D8
		RTL	
	
bugfix03:
PHA
lda $002002
CMP #$53
BEQ checkError
PLA
CMP #$2B
BCC $04
;JML $CC1D46   ; Englisch, Japan
;JML $CC1D3A   ; Englisch, Japan   
JML $CC1b93   ;Deutsch, Spanisch
JML $CC1b87   ; Deutsch, Spanisch
checkError:
lda $002000
AND #$08
BEQ continueMSU ;no error, play pcm	
PLA
CMP #$2B
BCC $04
;JML $CC1D46   ; Englisch, Japan
;JML $CC1D3A   ; Englisch, Japan 
JML $CC1b93    ;Deutsch, Spanisch
JML $CC1b87    ;Deutsch, Spanisch
continueMSU:
PLA
;JML $CC1D46 ; Englisch, Japan
JML $CC1b93 ;Deutsch, Spanisch

bugfixFade:
lda $002002
CMP #$53
BEQ $05
lda $00
cmp $bc
RTL
lda $00
cmp $7e0192
RTL

resume:
lda $002002
CMP #$53
BEQ $06
LDA $BC
STA $02DA
RTL
LDA $7e0192
STA $02DA
RTL

resume2:
lda $002002
CMP #$53
BEQ $06
LDA $BC
STA $062b
RTL
LDA $7e0192
STA $062b
RTL

previousTrack:
php
Sep #$20
LDA #$01
STA $7e0194
LDA $7e0193
JSL msu
Sep #$20
LDA $7e0192
STA $7e0193
LDA #$02
STA $7e0194
plp
JSL $C08D0B
RTL 

; loop table
org $c4fe00
; 01-Non-loop, 03-Loop
;   00  01  02  03  04  05  06  07  08  09  0A  0B  0C  0D  0E  0F
db $01,$03,$03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f - 00
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 10-1f - 10
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03,$03,$01,$03,$03 ; themes 20-2f - 20
db $01,$01,$03,$03,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; themes 30-3f - 30
db $01,$01,$01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 40-4f - 40
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 50-5f - 50
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 60-6f - 60
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 70-7f - 70

	